﻿local _, ns = ...

--边框变色
function ns.UpdateBorderColor(unitFrame,info)
	if unitFrame:IsForbidden() then return end
	if not unitFrame.unit then return end
local v = strsplit(".",GetBuildInfo())
if tonumber(v) < 11 then
	if UnitIsUnit(unitFrame.unit, "target") then
		if UnitIsPlayer(unitFrame.unit) then
			unitFrame.healthBar.border:SetVertexColor(0.8,0.8,0.8)
		else
			unitFrame.healthBar.border:SetVertexColor(1,1,1)
		end
	elseif unitFrame.useBorderColor and unitFrame.useBorderColor.spellId and PlateColorDB["Auras"][unitFrame.useBorderColor.spellId] and
		PlateColorDB["Auras"][unitFrame.useBorderColor.spellId]["useborder"] and unitFrame.useBorderColor.expirationTime-GetTime()>0.1 then
		local hpcid = unitFrame.useBorderColor.spellId
		local DB = PlateColorDB
		unitFrame.healthBar.border:SetVertexColor(DB["Auras"][hpcid]["color"]["r"],DB["Auras"][hpcid]["color"]["g"],DB["Auras"][hpcid]["color"]["b"])
	else
		unitFrame.healthBar.border:SetVertexColor(0,0,0)
	end	
else
	if UnitIsUnit(unitFrame.unit, "target") then
		if UnitIsPlayer(unitFrame.unit) then
			unitFrame.HealthBarsContainer.border:SetVertexColor(0.8,0.8,0.8)
		else
			unitFrame.HealthBarsContainer.border:SetVertexColor(1,1,1)
		end
	elseif unitFrame.useBorderColor and unitFrame.useBorderColor.spellId and PlateColorDB["Auras"][unitFrame.useBorderColor.spellId] and
		PlateColorDB["Auras"][unitFrame.useBorderColor.spellId]["useborder"] and unitFrame.useBorderColor.expirationTime-GetTime()>0.1 then
		local hpcid = unitFrame.useBorderColor.spellId
		local DB = PlateColorDB
		unitFrame.HealthBarsContainer.border:SetVertexColor(DB["Auras"][hpcid]["color"]["r"],DB["Auras"][hpcid]["color"]["g"],DB["Auras"][hpcid]["color"]["b"])
	else
		unitFrame.HealthBarsContainer.border:SetVertexColor(0,0,0)
	end	
end
end


local BarBorderColor = CreateFrame("Frame")
BarBorderColor:RegisterEvent("NAME_PLATE_UNIT_ADDED")
BarBorderColor:RegisterEvent("UNIT_AURA")
BarBorderColor:SetScript("OnEvent", function(self, event,frame)
	if not string.match(frame,"nameplate") then return end
	local namePlate = C_NamePlate.GetNamePlateForUnit(frame,false)
	if not namePlate then return end
	local unitFrame = namePlate.UnitFrame
	if not unitFrame.unit then return end
	if event == "UNIT_AURA" then
		local useborderid = unitFrame.useBorderColor and unitFrame.useBorderColor.spellId or 0
		if  PlateColorDB["Auras"][useborderid ] and PlateColorDB["Auras"][useborderid ]["useborder"] then
			ns.UpdateBorderColor(unitFrame)
		end
	elseif event == "NAME_PLATE_UNIT_ADDED" then
		ns.UpdateBorderColor(unitFrame)
	else
		ns.UpdateBorderColor(unitFrame)
	end
end)

hooksecurefunc("CompactUnitFrame_UpdateHealthBorder", function(frame)
	if frame:IsForbidden() then return end
	if not frame.unit then return end
	if frame.unit:lower():match("nameplate") then
		ns.UpdateBorderColor(frame)
	end
end)